## silo 0.8.5

=== Makefile ===
DIRS=first second silo

all clean dep depend:
	@for I in $(DIRS); do cd $$I; make $@ || exit 1; cd ..; done

ifeq (Linux,$(shell uname))
install:
	if [ \! -d /boot ]; then mkdir /boot; fi
	cp -f -b boot/*.b /boot
	if [ \! -f /etc/silo.conf ]; then cp etc/silo.conf /etc; fi
	cp -f -b sbin/silo /sbin
	/sbin/silo -f
else
ifeq (SunOS,$(shell uname -s))
ifeq (5.,$(findstring 5.,$(shell uname -r)))
install:
	if [ \! -d /boot ]; then mkdir /boot; fi
	cp -f -b boot/*.b /boot
	if [ \! -f /etc/silo.conf ]; then cp etc/silo.conf /etc; fi
	misc/solarissilo -f
else
install:
	@echo SunOS SILO not yet supported
endif
else
install:
	@echo SILO for other platforms not supported
endif
endif

=== first/Makefile ===
##
## Linux Loader for SPARC
##
#
VERSION=0.85

CC=gcc
LD=ld
AS=as
STRIP=strip
NM=nm

RM=/bin/rm -f
DD=dd
ELFTOAOUT=/usr/bin/elftoaout

# Linux
CFLAGS = -O2 -I../include -fomit-frame-pointer

# Relocate to 2.5MB. The Hitchhiker's Guide to Open Boot Rev 3 claims
# that 3MB are guaranteed to be mapped.
# Changing this value will require changing a bunch of other constants throughout the code
LDFLAGS=-N -Ttext 0x4000

.S.o:
	$(CC) $(CFLAGS) -c $*.S

ifeq (Linux,$(shell uname))
ifeq (sparc,$(subst sparc64,sparc,$(shell uname -m)))
all: first.b first.h ultra.b ultra.h cd.b cd.h fd.b

first.h: first
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*digit_here.*$$/#define DIGIT_OFFSET_TMP 0x\2/p;s/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define LETTER_OFFSET_TMP 0x\2/p' < first.map > first.h
ultra.h: ultra
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define ULTRA_LETTER_OFFSET_TMP 0x\2/p' < ultra.map > ultra.h
cd.h: cd
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*digit_here.*$$/#define CD_DIGIT_OFFSET_TMP 0x\2/p;s/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define CD_LETTER_OFFSET_TMP 0x\2/p' < cd.map > cd.h
else
all:
	@echo First stage bootblock should be build under Linux/Sparc only

first.h:
	@if [ ! -f first.h ]; then echo 'First do make under Linux/Sparc (and do not make clean until compiled on this platform)'; exit 1; fi
ultra.h:
	@if [ ! -f ultra.h ]; then echo 'First do make under Linux/Sparc (and do not make clean until compiled on this platform)'; exit 1; fi
cd.h:
	@if [ ! -f cd.h ]; then echo 'First do make under Linux/Sparc (and do not make clean until compiled on this platform)'; exit 1; fi
endif
else
all:
	@echo First stage bootblock should be build under Linux/Sparc only

first.h:
	@if [ ! -f first.h ]; then echo 'First do make under Linux/Sparc (and do not make clean until compiled on this platform)'; exit 1; fi
ultra.h:
	@if [ ! -f ultra.h ]; then echo 'First do make under Linux/Sparc (and do not make clean until compiled on this platform)'; exit 1; fi
cd.h:
	@if [ ! -f cd.h ]; then echo 'First do make under Linux/Sparc (and do not make clean until compiled on this platform)'; exit 1; fi
endif

first.o: first.S
	$(CC) $(CFLAGS) -c first.S -o first.o

first: first.o
	$(LD) $(LDFLAGS) -o first first.o
	$(NM) first | grep -v '*ABS*' | sort > first.map
	$(STRIP) first

first.b: first
	$(ELFTOAOUT) -o first.b first
	echo -n 'SILO'$(VERSION) | $(DD) of=first.b bs=8 conv=notrunc seek=3 count=1
	$(DD) if=/dev/zero of=first.b bs=4 count=1 seek=127
	ln -f first.b ../boot/first.b

ultra.o: ultra.S
	$(CC) $(CFLAGS) -E ultra.S -o ultra.s
	$(AS) -Av9a -o ultra.o ultra.s
	$(RM) ultra.s

ultra: ultra.o
	$(LD) $(LDFLAGS) -o ultra ultra.o
	$(NM) ultra | grep -v '*ABS*' | sort > ultra.map
	$(STRIP) ultra

ultra.b: ultra
	$(ELFTOAOUT) -o ultra.b ultra
	echo -n 'SILO'$(VERSION) | $(DD) of=ultra.b bs=8 conv=notrunc seek=3 count=1
	echo -n -e '\340' | $(DD) of=ultra.b bs=1 count=1 seek=7 conv=notrunc
	$(DD) if=/dev/zero of=ultra.b bs=4 count=1 seek=127
	ln -f ultra.b ../boot/ultra.b

cd.o: cd.S
	$(CC) $(CFLAGS) -E cd.S -o cd.s
	$(AS) -Av9a -o cd.o cd.s
	$(RM) cd.s

cd: cd.o
	$(LD) $(LDFLAGS) -o cd cd.o
	$(NM) cd | grep -v '*ABS*' | sort > cd.map
	$(STRIP) cd

cd.b: cd
	$(ELFTOAOUT) -o cd.b cd
	echo -n 'SILO'$(VERSION) | $(DD) of=cd.b bs=8 conv=notrunc seek=3 count=1
	echo -n -e '\340' | $(DD) of=cd.b bs=1 count=1 seek=7 conv=notrunc
	$(DD) if=/dev/zero of=cd.b bs=4 count=1 seek=255
	ln -f cd.b ../boot/cd.b

fd.o: fd.S
	$(CC) $(CFLAGS) -E fd.S -o fd.s
	$(AS) -Av9a -o fd.o fd.s
	$(RM) fd.s

fd: fd.o
	$(LD) $(LDFLAGS) -o fd fd.o
	$(NM) fd | grep -v '*ABS*' | sort > fd.map
	$(STRIP) fd

fd.b: fd
	$(ELFTOAOUT) -o fd.b fd
	echo -n 'SILO'$(VERSION) | $(DD) of=fd.b bs=8 conv=notrunc seek=3 count=1
	echo -n -e '\340' | $(DD) of=fd.b bs=1 count=1 seek=7 conv=notrunc
	$(DD) if=/dev/zero of=fd.b bs=4 count=1 seek=255
	ln -f fd.b ../boot/fd.b

clean:
	$(RM) *.o *~ first first.b first.map first.h ultra ultra.b ultra.s ultra.map ultra.h cd cd.b cd.s cd.map cd.h fd fd.b fd.s fd.map core

=== second/Makefile ===
##
## Linux Loader for SPARC
##
##

CC=gcc 
LD=ld
AS=as
RM=/bin/rm -f
NM=nm
DD=dd
ELFTOAOUT=elftoaout
STRIP=strip
GZIP=gzip
GDB=gdb
ECHO=echo
GREP=grep
SED=sed
CP=cp

CFLAGS = -I../include -O2 -I. 

# Relocate to 2.5MB. The Hitchhiker's Guide to Open Boot Rev 3 claims
# that 3MB are guaranteed to be mapped.
LDFLAGS=-N -Ttext 0x280000
LDFLAGS2=-N -Ttext 0x380000

.c.o:
	$(CC) $(CFLAGS) -c $*.c

.S.o:
	$(CC) $(CFLAGS) -c $*.S

# The ordering here is very significant. Please add new object files to OBJS5 only.
OBJS1 = crt0.o
OBJS2 = decomp.o
OBJS2N = decompnet.o
OBJS3 = console.o printf.o malloc.o jmp.o prom.o tree.o urem.o udiv.o stringops1.o
OBJS4 = main.o
OBJS4N = mainnet.o
OBJS5 = cmdline.o disk.o file.o misc.o cfg.o strtol.o ranges.o timer.o memory.o ufs.o romfs.o divdi3.o \
	mul.o rem.o sdiv.o umul.o stringops2.o
OBJS = $(OBJS1) $(OBJS2) $(OBJS3) bmark.o $(OBJS4) $(OBJS5)
OBJSNET = $(OBJS1) $(OBJS2N) $(OBJS3) bmark.o $(OBJS4N) $(OBJS5)

ifeq (Linux,$(shell uname))
ifeq (sparc,$(subst sparc64,sparc,$(shell uname -m)))
# Should really switch to autoconf...
LIBINC=$(shell if [ ! -f /lib/ld-linux.so.2 -o ! -f /usr/lib/libext2fs.so ]; then echo -L../include; fi)
all: second.b silotftp.b
else
all:
	@$(ECHO) Second stage bootloader should be build under Linux/Sparc only
endif
else
all:
	@$(ECHO) Second stage bootloader should be build under Linux/Sparc only
endif

second: $(OBJS) mark.o
	$(LD) $(LDFLAGS) -Bstatic -o second $(OBJS) $(LIBINC) -lext2fs mark.o
	$(LD) $(LDFLAGS2) -Bstatic -o second2 $(OBJS) $(LIBINC) -lext2fs mark.o
	$(NM) second | grep -v '*ABS*' | sort > second.map

silotftp: $(OBJSNET) mark.o
	$(LD) $(LDFLAGS) -Bstatic -o silotftp $(OBJSNET) $(LIBINC) -lext2fs mark.o
	$(LD) $(LDFLAGS2) -Bstatic -o silotftp2 $(OBJSNET) $(LIBINC) -lext2fs mark.o
	$(NM) silotftp | grep -v '*ABS*' | sort > silotftp.map

second.l: second
	( $(ECHO) 'disassemble 0x280000 '`$(GREP) '_etext' second.map | $(SED) 's/ .*$$//' | $(SED) 's/^00/0x/'`; $(ECHO) quit ) | $(GDB) second | $(SED) '1,/^(gdb)/d;/^End /,$$d' > second.l

main.o:        main.c silo.h
malloc.o:      malloc.c silo.h
printf.o:      printf.c silo.h
cmdline.o:     cmdline.c silo.h
console.o:     console.c silo.h
misc.o:	       misc.c silo.h
disk.o:	       disk.c silo.h
file.o:	       file.c silo.h ufs.h
cfg.o:	       cfg.c silo.h
ranges.o:      ranges.c silo.h
tree.o:	       tree.c silo.h
timer.o:       timer.c silo.h
decomp.o:      decomp.c inflate.c silo.h
mark.o:	       mark.S
bmark.o:       bmark.S
mul.o:         mul.S
umul.o:        umul.S
sdiv.o:        sdiv.S
udiv.o:        udiv.S
rem.o:         rem.S
urem.o:        urem.S
ufs.o:	       ufs.c silo.h ufs.h
romfs.o:       romfs.c silo.h
memory.o:      memory.c silo.h
jmp.o:	       jmp.S
divdi3.o:      divdi3.S
prom.o:	       prom.c promlib.h
decompnet.o:   decomp.c inflate.c silo.h
	$(CC) $(CFLAGS) -DTFTP -c -o decompnet.o decomp.c
mainnet.o:   main.c silo.h
	$(CC) $(CFLAGS) -DTFTP -c -o mainnet.o main.c

util:	util.c
	$(CC) -o util util.c

clean:
	$(RM) $(OBJS) *.o second second2 second.b silotftp silotftp2 silotftp.b second.l *.map core *~ util second.b second.image.tmp *.s

crt0.o:	crt0.S
	$(CC) $(CFLAGS) -E -o crt0.s crt0.S
	$(AS) -Av9 -o crt0.o crt0.s
	$(RM) crt0.s

prom.o: prom.c
	$(CC) $(CFLAGS) -S -o prom.s prom.c
	$(AS) -Av9 -o prom.o prom.s
	$(RM) prom.s

memory.o: memory.c
	$(CC) $(CFLAGS) -S -o memory.s memory.c
	$(AS) -Av9 -o memory.o memory.s
	$(RM) memory.s

timer.o: timer.c
	$(CC) $(CFLAGS) -S -o timer.s timer.c
	$(AS) -Av9a -o timer.o timer.s
	$(RM) timer.s

second.b: second util
	$(CP) second second.tmp
	$(CP) second2 second2.tmp
	$(STRIP) second.tmp
	$(STRIP) second2.tmp
	$(ELFTOAOUT) -o second.image.tmp second.tmp
	$(ELFTOAOUT) -o second2.image.tmp second2.tmp
	./util -z second.map second.image.tmp second2.image.tmp second.b second.b2
	$(GZIP) -9cfn second.b2 >> second.b
	$(RM) second.tmp second.image.tmp second2.tmp second2.image.tmp second.b2
	ln -f second.b ../boot/second.b

silotftp.b: silotftp util
	$(CP) silotftp silotftp.tmp
	$(CP) silotftp2 silotftp2.tmp
	$(STRIP) silotftp.tmp
	$(STRIP) silotftp2.tmp
	$(ELFTOAOUT) -o silotftp.image.tmp silotftp.tmp
	$(ELFTOAOUT) -o silotftp2.image.tmp silotftp2.tmp
	./util -a silotftp.map silotftp.image.tmp silotftp2.image.tmp silotftp.b silotftp.b2
	$(GZIP) -9cfn silotftp.b2 >> silotftp.b
	$(RM) silotftp.tmp silotftp.image.tmp silotftp2.tmp silotftp2.image.tmp silotftp.b2
	ln -f silotftp.b ../boot/silotftp.b

=== silo/Makefile ===
ifeq (Linux,$(shell uname))
ifeq (sparc,$(subst sparc64,sparc,$(shell uname -m)))
all: silo silocheck
else
all: intelsilo
endif
else
ifeq (SunOS,$(shell uname -s))
ifeq (5.,$(findstring 5.,$(shell uname -r)))
all: solarissilo solarissilocheck
else
all:
	@echo SunOS SILO not yet supported
endif
else
all:
	@echo SILO install program now supported on Linux/SPARC, Linux/i386
	@echo and Solaris only
endif
endif

silo: silo.c cdrom.h floppy.h prom.c prom.h first.h ultra.h cd.h
	gcc -I../include -I/usr/include -I/usr/src/linux/include -O2 -o silo silo.c prom.c
	strip silo
	ln -f silo ../sbin

silocheck: silocheck.c
	gcc -I../include -I/usr/include -I/usr/src/linux/include -O2 -o silocheck silocheck.c
	strip silocheck
	ln -f silocheck ../misc

intelsilo: silo.c cdrom.h floppy.h first.h ultra.h cd.h
	gcc -D__intel__ -I../include -I/usr/include -I/usr/src/linux/include -O2 -o intelsilo silo.c
	strip intelsilo
	ln -f intelsilo ../misc/intelsilo

solarissilo: silo.c ufs.c ufs.h cdrom.h floppy.h prom.c prom.h first.h ultra.h cd.h
	gcc -D__solaris__ -I../include -o solarissilo silo.c ufs.c prom.c
	strip solarissilo
	ln -f solarissilo ../misc

solarissilocheck: silocheck.c ufs.c ufs.h
	gcc -D__solaris__ -I../include -o solarissilocheck silocheck.c ufs.c
	strip solarissilocheck
	ln -f solarissilocheck ../misc

cdrom.h: cdrom.label util
	./util cdrom.label > cdrom.h

floppy.h: floppy.label util
	./util floppy.label | sed 's/cdrom/floppy/' > floppy.h

util: util.c
	gcc -o util util.c

ufs.h: ../second/ufs.h
	ln -sf ../second/ufs.h ufs.h

ufs.c: ../second/ufs.c
	ln -sf ../second/ufs.c ufs.c

first.h:
	cd ../first; make first.h

ultra.h:
	cd ../first; make ultra.h

cd.h:
	cd ../first; make cd.h

clean:
	rm -f $(INSTBOOT) $(TDEV) *.o *~ silo solarissilo sunossilo intelsilo cdrom.h floppy.h util silocheck solarissilocheck ufs.[ch]

## silo 0.9.8

=== first/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 ## Linux Loader for SPARC
 ##
 #
-VERSION=0.85
+VERSION=0.98
 
 CC=gcc
 LD=ld
@@ -27,35 +27,37 @@
 
 ifeq (Linux,$(shell uname))
 ifeq (sparc,$(subst sparc64,sparc,$(shell uname -m)))
-all: first.b first.h ultra.b ultra.h cd.b cd.h fd.b
+all: first.b first.h ultra.b ultra.h cd.b generic.b generic.h fd.b ieee32.b
 
 first.h: first
-	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*digit_here.*$$/#define DIGIT_OFFSET_TMP 0x\2/p;s/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define LETTER_OFFSET_TMP 0x\2/p' < first.map > first.h
+	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*digit_here.*$$/#define DIGIT_OFFSET_TMP 0x\2/p' < first.map > first.h
+	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define LETTER_OFFSET_TMP 0x\2/p' < first.map >> first.h
+	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*number_here.*$$/#define NUMBER_OFFSET_TMP 0x\2/p' < first.map >> first.h
 ultra.h: ultra
 	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define ULTRA_LETTER_OFFSET_TMP 0x\2/p' < ultra.map > ultra.h
-cd.h: cd
-	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*digit_here.*$$/#define CD_DIGIT_OFFSET_TMP 0x\2/p;s/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define CD_LETTER_OFFSET_TMP 0x\2/p' < cd.map > cd.h
+	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*number_here.*$$/#define ULTRA_NUMBER_OFFSET_TMP 0x\2/p' < ultra.map >> ultra.h
+generic.h: generic
+	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*digit_here.*$$/#define GENERIC_DIGIT_OFFSET_TMP 0x\2/p' < generic.map > generic.h
+	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define GENERIC_LETTER_OFFSET_TMP 0x\2/p' < generic.map >> generic.h
+	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*number_here.*$$/#define GENERIC_NUMBER_OFFSET_TMP 0x\2/p' < generic.map >> generic.h
+fd.h: fd
+	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*digit_here.*$$/#define FD_DIGIT_OFFSET_TMP 0x\2/p' < fd.map > fd.h
+	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define FD_LETTER_OFFSET_TMP 0x\2/p' < fd.map >> fd.h
+ieee32.h: ieee32.b
+	objdump -h ieee32.b | awk ' $$2 ~ /\.text/ { sub(/^0*/,"",$$6); printf "#define IEEE32_OFFSET_TMP 0x%s\n", $$6 } ' > ieee32.h
 else
 all:
 	@echo First stage bootblock should be build under Linux/Sparc only
 
-first.h:
+first.h ultra.h generic.h fd.h ieee32.h:
 	@if [ ! -f first.h ]; then echo 'First do make under Linux/Sparc (and do not make clean until compiled on this platform)'; exit 1; fi
-ultra.h:
-	@if [ ! -f ultra.h ]; then echo 'First do make under Linux/Sparc (and do not make clean until compiled on this platform)'; exit 1; fi
-cd.h:
-	@if [ ! -f cd.h ]; then echo 'First do make under Linux/Sparc (and do not make clean until compiled on this platform)'; exit 1; fi
 endif
 else
 all:
 	@echo First stage bootblock should be build under Linux/Sparc only
 
-first.h:
+first.h ultra.h generic.h fd.h ieee32.h:
 	@if [ ! -f first.h ]; then echo 'First do make under Linux/Sparc (and do not make clean until compiled on this platform)'; exit 1; fi
-ultra.h:
-	@if [ ! -f ultra.h ]; then echo 'First do make under Linux/Sparc (and do not make clean until compiled on this platform)'; exit 1; fi
-cd.h:
-	@if [ ! -f cd.h ]; then echo 'First do make under Linux/Sparc (and do not make clean until compiled on this platform)'; exit 1; fi
 endif
 
 first.o: first.S
@@ -106,6 +108,23 @@
 	$(DD) if=/dev/zero of=cd.b bs=4 count=1 seek=255
 	ln -f cd.b ../boot/cd.b
 
+generic.o: generic.S
+	$(CC) $(CFLAGS) -E generic.S -o generic.s
+	$(AS) -Av9a -o generic.o generic.s
+	$(RM) generic.s
+
+generic: generic.o
+	$(LD) $(LDFLAGS) -o generic generic.o
+	$(NM) generic | grep -v '*ABS*' | sort > generic.map
+	$(STRIP) generic
+
+generic.b: generic
+	$(ELFTOAOUT) -o generic.b generic
+	echo -n 'SILO'$(VERSION) | $(DD) of=generic.b bs=8 conv=notrunc seek=3 count=1
+	echo -n -e '\340' | $(DD) of=generic.b bs=1 count=1 seek=7 conv=notrunc
+	$(DD) if=/dev/zero of=generic.b bs=4 count=1 seek=255
+	#ln -f generic.b ../boot/generic.b
+
 fd.o: fd.S
 	$(CC) $(CFLAGS) -E fd.S -o fd.s
 	$(AS) -Av9a -o fd.o fd.s
@@ -123,5 +142,17 @@
 	$(DD) if=/dev/zero of=fd.b bs=4 count=1 seek=255
 	ln -f fd.b ../boot/fd.b
 
+ieee32.o: ieee32.S
+	$(CC) $(CFLAGS) -DVERSION='"SILO$(VERSION)"' -c ieee32.S
+
+ieee32.b: ieee32.o
+	$(LD) $(LDFLAGS) -o ieee32.b ieee32.o
+	$(NM) ieee32.b | grep -v '*ABS*' | sort > ieee32.map
+	$(STRIP) ieee32.b
+	chmod 644 ieee32.b
+	ln -f ieee32.b ../boot/ieee32.b
+
 clean:
-	$(RM) *.o *~ first first.b first.map first.h ultra ultra.b ultra.s ultra.map ultra.h cd cd.b cd.s cd.map cd.h fd fd.b fd.s fd.map core
+	$(RM) *.o *~ first first.b first.map first.h ultra ultra.b ultra.s ultra.map ultra.h \
+	ieee32.b ieee32.map ieee32.h \
+	cd cd.b cd.s cd.map generic generic.b generic.s generic.map generic.h fd.h fd fd.b fd.s fd.map core

=== second/Makefile ===
--- 
+++ 
@@ -3,12 +3,15 @@
 ##
 ##
 
+VERSION=0.98
 CC=gcc 
 LD=ld
 AS=as
 RM=/bin/rm -f
 NM=nm
 DD=dd
+AWK=awk
+LS=ls
 ELFTOAOUT=elftoaout
 STRIP=strip
 GZIP=gzip
@@ -18,7 +21,7 @@
 SED=sed
 CP=cp
 
-CFLAGS = -I../include -O2 -I. 
+CFLAGS = -I../include -O2 -I. -Wall
 
 # Relocate to 2.5MB. The Hitchhiker's Guide to Open Boot Rev 3 claims
 # that 3MB are guaranteed to be mapped.
@@ -38,8 +41,8 @@
 OBJS3 = console.o printf.o malloc.o jmp.o prom.o tree.o urem.o udiv.o stringops1.o
 OBJS4 = main.o
 OBJS4N = mainnet.o
-OBJS5 = cmdline.o disk.o file.o misc.o cfg.o strtol.o ranges.o timer.o memory.o ufs.o romfs.o divdi3.o \
-	mul.o rem.o sdiv.o umul.o stringops2.o
+OBJS5 = cmdline.o disk.o file.o misc.o cfg.o strtol.o ranges.o timer.o memory.o ufs.o romfs.o 9660.o divdi3.o \
+	mul.o rem.o sdiv.o umul.o stringops2.o ls.o muldi3.o
 OBJS = $(OBJS1) $(OBJS2) $(OBJS3) bmark.o $(OBJS4) $(OBJS5)
 OBJSNET = $(OBJS1) $(OBJS2N) $(OBJS3) bmark.o $(OBJS4N) $(OBJS5)
 
@@ -71,6 +74,7 @@
 	( $(ECHO) 'disassemble 0x280000 '`$(GREP) '_etext' second.map | $(SED) 's/ .*$$//' | $(SED) 's/^00/0x/'`; $(ECHO) quit ) | $(GDB) second | $(SED) '1,/^(gdb)/d;/^End /,$$d' > second.l
 
 main.o:        main.c silo.h
+ls.o:          ls.c silo.h
 malloc.o:      malloc.c silo.h
 printf.o:      printf.c silo.h
 cmdline.o:     cmdline.c silo.h
@@ -109,7 +113,7 @@
 	$(RM) $(OBJS) *.o second second2 second.b silotftp silotftp2 silotftp.b second.l *.map core *~ util second.b second.image.tmp *.s
 
 crt0.o:	crt0.S
-	$(CC) $(CFLAGS) -E -o crt0.s crt0.S
+	$(CC) $(CFLAGS) -E -o crt0.s -DVERSION='"SILO$(VERSION)"' crt0.S
 	$(AS) -Av9 -o crt0.o crt0.s
 	$(RM) crt0.s
 
@@ -137,6 +141,8 @@
 	$(ELFTOAOUT) -o second2.image.tmp second2.tmp
 	./util -z second.map second.image.tmp second2.image.tmp second.b second.b2
 	$(GZIP) -9cfn second.b2 >> second.b
+	$(DD) if=/dev/zero bs=1 count=`$(LS) -l second.b | $(AWK) '{len=$$5%512;if(len!=0)len=512-len;print len}'` >> second.b
+	$(LS) -l second.b | $(AWK) '{printf "%c%c%c%c",0,$$5/65536,($$5%65536)/256,0}' | $(DD) of=second.b bs=4 count=1 seek=581 conv=notrunc
 	$(RM) second.tmp second.image.tmp second2.tmp second2.image.tmp second.b2
 	ln -f second.b ../boot/second.b

=== silo/Makefile ===
ifeq (Linux,$(shell uname))
ifeq (sparc,$(subst sparc64,sparc,$(shell uname -m)))
all: silo silocheck
else
all:
	@echo SILO install program now supported on Linux/SPARC and Solaris only
endif
else
ifeq (SunOS,$(shell uname -s))
ifeq (5.,$(findstring 5.,$(shell uname -r)))
all: solarissilo solarissilocheck
else
all:
	@echo SunOS SILO not yet supported
endif
else
all:
	@echo SILO install program now supported on Linux/SPARC and Solaris only
endif
endif

silo: silo.c floppy.h prom.c prom.h headers
	gcc -Wall -I../include -I/usr/include -I/usr/src/linux/include -O2 -o silo silo.c prom.c
	strip silo
	ln -f silo ../sbin

silocheck: silocheck.c
	gcc -I../include -I/usr/include -I/usr/src/linux/include -O2 -o silocheck silocheck.c
	strip silocheck
	ln -f silocheck ../misc

solarissilo: silo.c ufs.c ufs.h floppy.h prom.c prom.h headers
	gcc -D__solaris__ -I../include -o solarissilo silo.c ufs.c prom.c
	strip solarissilo
	ln -f solarissilo ../misc

solarissilocheck: silocheck.c ufs.c ufs.h
	gcc -D__solaris__ -I../include -o solarissilocheck silocheck.c ufs.c
	strip solarissilocheck
	ln -f solarissilocheck ../misc

floppy.h: floppy.label util
	./util floppy.label | sed 's/cdrom/floppy/' > floppy.h

util: util.c
	gcc -o util util.c

ufs.h: ../second/ufs.h
	ln -sf ../second/ufs.h ufs.h

ufs.c: ../second/ufs.c
	ln -sf ../second/ufs.c ufs.c

headers:
	cd ../first; make first.h ultra.h fd.h ieee32.h

clean:
	rm -f $(INSTBOOT) $(TDEV) *.o *~ silo solarissilo sunossilo floppy.h util silocheck solarissilocheck ufs.[ch]

## silo 1.2.5

=== Makefile ===
include Rules.make

# These only get built on Linux
ifeq ($(OPSYS),Linux)
  SUBDIRS  = common first second tilo
  MANPAGES = maketilo.1 tilo.1
endif

# These get built on Linux and Solaris
MANPAGES += silo.8 silo.conf.5
SUBDIRS  += silo

all dep depend clean:
	@for I in $(SUBDIRS); do $(MAKE) -C $$I $@ || exit 1; done

ifeq ($(OPSYS),$(findstring $(OPSYS),Linux Solaris))
install:
	install -d -m755 $(DESTDIR)/etc $(DESTDIR)/sbin $(DESTDIR)/usr/sbin
	install -m755 silo/silo $(DESTDIR)/sbin
	install -m755 silo/silocheck $(DESTDIR)/usr/sbin
	[ -f $(DESTDIR)/etc/silo.conf ] || \
		install -m644 etc/silo.conf $(DESTDIR)/etc/
 ifeq ($(OPSYS),Linux)
	install -d -m755 $(DESTDIR)/boot $(DESTDIR)/usr/bin
	install -m644 first/*.b second/*.b $(DESTDIR)/boot/
	install -m755 tilo/maketilo $(DESTDIR)/usr/bin/
	install -m755 tilo/tilo.sh $(DESTDIR)/usr/bin/tilo
 endif
	for manpage in $(MANPAGES); do \
		sect=`echo $$manpage | sed 's/.*\([1-8]\)$$/\1/'`; \
		install -d -m755 $(DESTDIR)/usr/share/man/man$$sect; \
		install -m644 man/$$manpage $(DESTDIR)/usr/share/man/man$$sect/; \
	done
	if test x"$(DESTDIR)" = x; then \
		echo "You need to run 'silo -f' now, to update the boot block" 1>&2; \
	fi
else
install:
	@echo SILO is only supported on SPARC Linux and Solaris.
endif

# This is just for me to make release tarballs
release: ../silo-loaders-$(VERSION).tar.gz ../silo-$(VERSION).tar.gz ../silo-$(VERSION).tar.bz2
	rm -rf ../silo-$(VERSION) boot

../silo-loaders-$(VERSION).tar%:
	if ! test -d boot; then \
		for I in first second; do $(MAKE) -C $$I all || exit 1; done; \
		install -d -m755  boot; \
		install -m644 first/*.b second/*.b boot/; \
	fi
	case "$*" in .gz) foo="gzip -c9";; .bz2) foo="bzip2 -c9";; *) foo=cat;; esac; \
		tar cf - boot | $$foo > $@
	rm -rf boot

../silo-$(VERSION).tar%: clean
	if ! test -d ../silo-$(VERSION); then \
		install -d -m755 ../silo-$(VERSION); \
		cp -a ./ ../silo-$(VERSION); \
	fi
	cd ../silo-$(VERSION) && find -name .\#\* -o -name CVS -o -name .cvsignore | \
		xargs -r rm -rf
	case "$*" in .gz) foo="gzip -c9";; .bz2) foo="bzip2 -c9";; *) foo=cat;; esac; \
		(cd ../ && tar cf - silo-$(VERSION)) | $$foo > $@

=== common/Makefile ===
##
## Common files between tilo and silo
##

include ../Rules.make

.c.o:
	$(CC) $(CFLAGS) -c $*.c

.S.o:
	$(CC) $(CFLAGS) -c $*.S

OBJS = udiv.o urem.o jmp.o printf.o console.o prom.o tree.o stringops2.o stringops1.o ffs.o
PROGRAMS = bin2h

all: $(OBJS) $(PROGRAMS)

prom.o: prom.c
	$(CC) $(CFLAGS) -c -Wa,-Av9 -o prom.o prom.c

clean:
	$(RM) $(PROGRAMS) *.o

=== first/Makefile ===
##
## Linux Loader for SPARC
##
#

CC=gcc
LD=ld
AS=as
STRIP=strip
NM=nm

RM=/bin/rm -f
DD=dd
ELFTOAOUT=/usr/bin/elftoaout

include ../Rules.make

# Relocate to 2.5MB. The Hitchhiker's Guide to Open Boot Rev 3 claims
# that 3MB are guaranteed to be mapped.
# Changing this value will require changing a bunch of other constants throughout the code
LDFLAGS=-N -Ttext 0x4000

.S.o:
	$(CC) $(CFLAGS) -c $*.S

all: first.b first.h ultra.b ultra.h cd.b generic.b generic.h fd.b ieee32.b

first.h: first
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*digit_here.*$$/#define DIGIT_OFFSET_TMP 0x\2/p' < first.map > first.h
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define LETTER_OFFSET_TMP 0x\2/p' < first.map >> first.h
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*number_here.*$$/#define NUMBER_OFFSET_TMP 0x\2/p' < first.map >> first.h
ultra.h: ultra
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define ULTRA_LETTER_OFFSET_TMP 0x\2/p' < ultra.map > ultra.h
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*number_here.*$$/#define ULTRA_NUMBER_OFFSET_TMP 0x\2/p' < ultra.map >> ultra.h
generic.h: generic
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*digit_here.*$$/#define GENERIC_DIGIT_OFFSET_TMP 0x\2/p' < generic.map > generic.h
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define GENERIC_LETTER_OFFSET_TMP 0x\2/p' < generic.map >> generic.h
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*number_here.*$$/#define GENERIC_NUMBER_OFFSET_TMP 0x\2/p' < generic.map >> generic.h
fd.h: fd
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*digit_here.*$$/#define FD_DIGIT_OFFSET_TMP 0x\2/p' < fd.map > fd.h
	sed -n 's/^\(000000000000\|0000\)4\([0-9a-f][0-9a-f][0-9a-f]\) .*letter_here.*$$/#define FD_LETTER_OFFSET_TMP 0x\2/p' < fd.map >> fd.h

first.o: first.S
	$(CC) $(CFLAGS) -c first.S -o first.o

first: first.o
	$(LD) $(LDFLAGS) -o first first.o
	$(NM) first | grep -v '*ABS*' | sort > first.map
	$(STRIP) first

first.b: first
	$(ELFTOAOUT) -o first.b first
	echo -n 'SILO'$(IMGVERSION) | $(DD) of=first.b bs=8 conv=notrunc seek=3 count=1
	$(DD) if=/dev/zero of=first.b bs=4 count=1 seek=127

ultra.o: ultra.S
	$(CC) $(CFLAGS) -c -Wa,-Av9a ultra.S

ultra: ultra.o
	$(LD) $(LDFLAGS) -o ultra ultra.o
	$(NM) ultra | grep -v '*ABS*' | sort > ultra.map
	$(STRIP) ultra

ultra.b: ultra
	$(ELFTOAOUT) -o ultra.b ultra
	echo -n 'SILO'$(IMGVERSION) | $(DD) of=ultra.b bs=8 conv=notrunc seek=3 count=1
	echo -n -e '\340' | $(DD) of=ultra.b bs=1 count=1 seek=7 conv=notrunc
	$(DD) if=/dev/zero of=ultra.b bs=4 count=1 seek=127

cd.o: cd.S
	$(CC) $(CFLAGS) -c -Wa,-Av9a cd.S

cd: cd.o
	$(LD) $(LDFLAGS) -o cd cd.o
	$(NM) cd | grep -v '*ABS*' | sort > cd.map
	$(STRIP) cd

cd.b: cd
	$(ELFTOAOUT) -o cd.b cd
	echo -n 'SILO'$(IMGVERSION) | $(DD) of=cd.b bs=8 conv=notrunc seek=3 count=1
	echo -n -e '\340' | $(DD) of=cd.b bs=1 count=1 seek=7 conv=notrunc
	$(DD) if=/dev/zero of=cd.b bs=4 count=1 seek=255

generic.o: generic.S
	$(CC) $(CFLAGS) -c -Wa,-Av9a generic.S

generic: generic.o
	$(LD) $(LDFLAGS) -o generic generic.o
	$(NM) generic | grep -v '*ABS*' | sort > generic.map
	$(STRIP) generic

generic.b: generic
	$(ELFTOAOUT) -o generic.b generic
	echo -n 'SILO'$(IMGVERSION) | $(DD) of=generic.b bs=8 conv=notrunc seek=3 count=1
	echo -n -e '\340' | $(DD) of=generic.b bs=1 count=1 seek=7 conv=notrunc
	$(DD) if=/dev/zero of=generic.b bs=4 count=1 seek=255

fd.o: fd.S
	$(CC) $(CFLAGS) -c -Wa,-Av9a fd.S

fd: fd.o
	$(LD) $(LDFLAGS) -o fd fd.o
	$(NM) fd | grep -v '*ABS*' | sort > fd.map
	$(STRIP) fd

fd.b: fd
	$(ELFTOAOUT) -o fd.b fd
	echo -n 'SILO'$(IMGVERSION) | $(DD) of=fd.b bs=8 conv=notrunc seek=3 count=1
	echo -n -e '\340' | $(DD) of=fd.b bs=1 count=1 seek=7 conv=notrunc
	$(DD) if=/dev/zero of=fd.b bs=4 count=1 seek=255

ieee32.o: ieee32.S ieee32.h
	$(CC) $(CFLAGS) -DIMGVERSION='"SILO$(IMGVERSION)"' -c ieee32.S

ieee32.b: ieee32.o
	$(LD) $(LDFLAGS) -o ieee32.b ieee32.o
	$(NM) ieee32.b | grep -v '*ABS*' | sort > ieee32.map
	$(STRIP) ieee32.b
	chmod 644 ieee32.b

clean:
	$(RM) *.o *.map *.b first first.h ultra ultra.h \
	generic generic.h fd fd.h cd

=== second/Makefile ===
##
## Linux Loader for SPARC
##
##

AS=as
AR=ar
NM=nm
DD=dd
AWK=awk
LS=ls
STRIP=strip
GZIP=gzip
GDB=gdb
ECHO=echo
GREP=grep
SED=sed
CP=cp

include ../Rules.make

# Relocate to 2.5MB. The Hitchhiker's Guide to Open Boot Rev 3 claims
# that 3MB are guaranteed to be mapped.
LDFLAGS_SMALL=-N -Ttext 0x280000
LDFLAGS_LARGE=-N -Ttext 0x380000

.c.o:
	$(CC) $(CFLAGS) -c $*.c -o $@

.S.o:
	$(CC) $(CFLAGS) -c $*.S -o $@

# The ordering here is very significant. Please add new object files to OBJS5 only.
OBJS1 = crt0.o
OBJS2 = decomp.o
OBJS2N = decompnet.o
OBJS3 = ../common/console.o ../common/printf.o malloc.o ../common/jmp.o \
	../common/prom.o ../common/tree.o ../common/urem.o ../common/udiv.o \
	../common/stringops1.o ../common/ffs.o
OBJS4 = main.o
OBJS4N = mainnet.o
OBJS5 = cmdline.o disk.o file.o misc.o cfg.o strtol.o ranges.o timer.o \
	memory.o fs/libfs.a divdi3.o mul.o rem.o sdiv.o umul.o \
	../common/stringops2.o ls.o muldi3.o
OBJS = $(OBJS1) $(OBJS2) $(OBJS3) bmark.o $(OBJS4) $(OBJS5)
OBJSNET = $(OBJS1) $(OBJS2N) $(OBJS3) bmark.o $(OBJS4N) $(OBJS5)

FS_OBJS = fs/iom.o fs/ext2.o fs/isofs.o fs/romfs.o fs/ufs.o

# Should really switch to autoconf...
all: second.b silotftp.b

fs/libfs.a: $(FS_OBJS)
	$(RM) $@
	$(AR) rc $@ $(FS_OBJS)

second: $(OBJS) mark.o
	$(LD) $(LDFLAGS_SMALL) -Bstatic -o second $(OBJS) -lext2fs mark.o
	$(LD) $(LDFLAGS_LARGE) -Bstatic -o second2 $(OBJS) -lext2fs mark.o
	$(NM) second | grep -v '*ABS*' | sort > second.map

silotftp: $(OBJSNET) mark.o
	$(LD) $(LDFLAGS_SMALL) -Bstatic -o silotftp $(OBJSNET) -lext2fs mark.o
	$(LD) $(LDFLAGS_LARGE) -Bstatic -o silotftp2 $(OBJSNET) -lext2fs mark.o
	$(NM) silotftp | grep -v '*ABS*' | sort > silotftp.map

second.l: second
	( $(ECHO) 'disassemble 0x280000 '`$(GREP) '_etext' second.map | $(SED) 's/ .*$$//' | $(SED) 's/^00/0x/'`; $(ECHO) quit ) | $(GDB) second | $(SED) '1,/^(gdb)/d;/^End /,$$d' > second.l

file.o:	       file.c

decompnet.o:   decomp.c
	$(CC) $(CFLAGS) -DTFTP -c -o decompnet.o decomp.c
mainnet.o:   main.c
	$(CC) $(CFLAGS) -DTFTP -c -o mainnet.o main.c

malloc.o: ../common/malloc.c
	$(CC) $(CFLAGS) -c -o malloc.o ../common/malloc.c

util:	util.c
	$(CC) -o util util.c

clean:
	$(RM) *.o fs/*.o second* silotftp* *.map util fs/libfs.a

crt0.o:	crt0.S
	$(CC) $(CFLAGS) -c -Wa,-Av9 -DIMGVERSION='"SILO$(IMGVERSION)"' crt0.S

memory.o: memory.c
	$(CC) $(CFLAGS) -c -Wa,-Av9 memory.c

timer.o: timer.c
	$(CC) $(CFLAGS) -c -Wa,-Av9a timer.c

second.b: second util
	$(CP) second second.tmp
	$(CP) second2 second2.tmp
	$(STRIP) second.tmp
	$(STRIP) second2.tmp
	$(ELFTOAOUT) -o second.image.tmp second.tmp
	$(ELFTOAOUT) -o second2.image.tmp second2.tmp
	./util -z second.map second.image.tmp second2.image.tmp second.b second.b2
	$(GZIP) -9cfn second.b2 >> second.b
	$(DD) if=/dev/zero bs=1 count=`$(LS) -l second.b | $(AWK) '{len=$$5%512;if(len!=0)len=512-len;print len}'` >> second.b
	$(LS) -l second.b | $(AWK) '{printf "%c%c%c%c",0,$$5/65536,($$5%65536)/256,0}' | $(DD) of=second.b bs=4 count=1 seek=581 conv=notrunc
	$(RM) second.tmp second.image.tmp second2.tmp second2.image.tmp second.b2

silotftp.b: silotftp util
	$(CP) silotftp silotftp.tmp
	$(CP) silotftp2 silotftp2.tmp
	$(STRIP) silotftp.tmp
	$(STRIP) silotftp2.tmp
	$(ELFTOAOUT) -o silotftp.image.tmp silotftp.tmp
	$(ELFTOAOUT) -o silotftp2.image.tmp silotftp2.tmp
	./util -a silotftp.map silotftp.image.tmp silotftp2.image.tmp silotftp.b silotftp.b2
	$(GZIP) -9cfn silotftp.b2 >> silotftp.b
	$(RM) silotftp.tmp silotftp.image.tmp silotftp2.tmp silotftp2.image.tmp silotftp.b2

=== silo/Makefile ===
include ../Rules.make

PROGRAMS=silo silocheck
UFSDEPS=

ifeq ($(OPSYS),Solaris)
  UFSDEPS=../second/ufs.c ufs.h
endif

all: $(PROGRAMS)

HEADERS=../first/first.h ../first/ultra.h ../first/fd.h
SILO_OBJS=confcheck.o prom.o silo.o
SILOCHK_OBJS=silocheck.o

silo: $(HEADERS) $(SILO_OBJS)
	$(CC) -O2 -o $@ $(SILO_OBJS)

silocheck: $(SILOCHK_OBJS) $(UFSDEPS)
	$(CC) -O2 -o $@ $(SILOCHK_OBJS)

floppy.h: floppy.label $(BIN2H)
	$(BIN2H) floppy_label floppy.label > floppy.h

ufs.h: ../second/ufs.h
	ln -f ../second/ufs.h ufs.h

$(HEADERS):
	$(MAKE) -C ../first first.h ultra.h fd.h

silo.o: silo.c floppy.h $(UFSDEPS)
	$(CC) $(CFLAGS) -DVERSION='"$(VERSION)"' -DIMGVERSION='"$(IMGVERSION)"' -c silo.c

clean:
	$(RM) *.o silo floppy.h ufs.h silocheck

=== tilo/Makefile ===
##
## Trivial Linux Loader for SPARC
##
##

include ../Rules.make

# Relocate to 3.75MB
# Hopefully, 4MB are guaranteed to be mapped.
LDFLAGS_SMALL=-N -Ttext 0x3c0000
# This is even more, but will be used only for extra large images.
LDFLAGS_LARGE=-N -Ttext 0x4c0000

all: maketilo

.c.o:
	$(CC) $(CFLAGS) -c $*.c

.S.o:
	$(CC) $(CFLAGS) -c $*.S

OBJS_COMMON = ../common/printf.o ../common/jmp.o ../common/prom.o \
	../common/tree.o ../common/console.o ../common/stringops1.o \
	../common/urem.o ../common/stringops2.o ../common/udiv.o
OBJS = crt0.o tilo.o $(OBJS_COMMON) malloc.o
OBJS2 = crt0l.o tilol.o $(OBJS_COMMON) mallocl.o

maketilo: maketilo.c b.h b2.h
	$(CC) $(CFLAGS) maketilo.c -o maketilo

b.h : b.out $(BIN2H)
	$(BIN2H) -l BOOT_LEN boot_loader $< > $@ || ($(RM) $@; exit 1)

b2.h : b2.out $(BIN2H)
	$(BIN2H) -l LARGE_BOOT_LEN large_boot_loader $< > $@ || ($(RM) $@; exit 1)

b.out: $(OBJS)
	$(LD) $(LDFLAGS_SMALL) -Bstatic -o boot $(OBJS)
	$(ELFTOAOUT) boot -o b.out

b2.out: $(OBJS2)
	$(LD) $(LDFLAGS_LARGE) -Bstatic -o boot2 $(OBJS2)
	$(ELFTOAOUT) boot2 -o b2.out


mallocl.o: ../common/malloc.c
	$(CC) $(CFLAGS) -DMALLOC_BASE=0x4D0000 -c -o $@ $<

malloc.o: ../common/malloc.c
	$(CC) $(CFLAGS) -DMALLOC_BASE=0x3D0000 -c -o $@ $<

tilol.o: tilo.c
	$(CC) $(CFLAGS) -DLARGETILO -c -o $@ $<

crt0.o:	crt0.S
	$(CC) $(CFLAGS) -c -Wa,-Av9 -o $@ $<

crt0l.o: crt0.S
	$(CC) $(CFLAGS) -c -Wa,-Av9 -DLARGETILO -o $@ $<

clean:
	$(RM) *.o boot boot2 *.out b.h b2.h maketilo

## silo 1.4.6-1

=== debian/changelog ===
silo (1.4.6-1) unstable; urgency=low

  * New upstream, partially fixes initrd issues.

 -- Ben Collins <bcollins@debian.org>  Sun, 20 Jun 2004 13:11:48 -0400

silo (1.4.5-1) unstable; urgency=low

  * New upstream fixes "illegal instruction" on some sparc64 hardware.
  * Fixed ext2fs for SELINUX: Closes: #232009
  * Added bzip2 build-dep. Closes: #239479

 -- Ben Collins <bcollins@debian.org>  Thu, 13 May 2004 09:58:53 -0400

silo (1.4.4-1) unstable; urgency=low

  * New upstream. Fixes sparc32 boots.

 -- Ben Collins <bcollins@debian.org>  Fri, 30 Jan 2004 15:18:24 -0500

silo (1.4.3-1) unstable; urgency=low

  * New upstream resolves one other problem with initrd.

 -- Ben Collins <bcollins@debian.org>  Thu, 29 Jan 2004 14:09:59 -0500

silo (1.4.2-1) unstable; urgency=low

  * Get the version right this time.

 -- Ben Collins <bcollins@debian.org>  Thu, 29 Jan 2004 13:34:01 -0500

silo (1.4.1-2) unstable; urgency=low

  * New upstream. Fixes initrd.

 -- Ben Collins <bcollins@debian.org>  Thu, 29 Jan 2004 13:31:04 -0500

silo (1.4.1-1) unstable; urgency=low

  * New upstream. Allows larger kernels to be loaded (kernels must be patched
    to support this).
  * Adds "partition-boot" config option, which is the same as -t.
    closes: #145267, #98314
  * Silo is no longer essential: closes: #214005

 -- Ben Collins <bcollins@debian.org>  Wed, 28 Jan 2004 12:24:28 -0500

silo (1.3.2-1) unstable; urgency=low

  * New upstream, fixes initrd boots with some larger kernels.

 -- Ben Collins <bcollins@debian.org>  Wed,  3 Dec 2003 21:13:53 -0500

silo (1.3.1-2) unstable; urgency=low

  * Force use of gcc-2.95 to fix some problems with illegal instruction.

 -- Ben Collins <bcollins@debian.org>  Mon, 29 Sep 2003 10:48:07 -0400

silo (1.3.1-1) unstable; urgency=low

  * New upstream.
  * Rename 1440 disk images.

 -- Ben Collins <bcollins@debian.org>  Fri,  8 Aug 2003 12:59:38 -0400

silo (1.3.0-1) unstable; urgency=low

  * New upstream, includes new isofs.b boot block for mkisofs.
  * Move everything to /boot. Provide upgrades and base installs. This will
    make it simpler for people to have a seperate /boot. Still need a way to
    migrate vmlinuz symlink being in /boot aswell.

 -- Ben Collins <bcollins@debian.org>  Thu,  3 Apr 2003 10:01:46 -0500

silo (1.2.6-1) unstable; urgency=low

  * New upstream. Adds support for UltraSPARC III+ (Cheetah+)

 -- Ben Collins <bcollins@debian.org>  Wed, 14 Aug 2002 21:56:14 -0400

silo (1.2.5-1) unstable; urgency=low

  * New upstream version. Fixes a first stage boot loader bug.

 -- Ben Collins <bcollins@debian.org>  Fri, 29 Mar 2002 13:36:49 -0500

silo (1.2.4-1) unstable; urgency=low

  * New upstream fixes TILO buglet.

 -- Ben Collins <bcollins@debian.org>  Tue, 13 Nov 2001 21:59:00 -0500

silo (1.2.3-1) unstable; urgency=low

  * New upstream, fixes tilo.

 -- Ben Collins <bcollins@debian.org>  Fri, 10 Aug 2001 00:32:23 -0400

silo (1.2.2-1) unstable; urgency=low

  * New upstream.

 -- Ben Collins <bcollins@debian.org>  Sat, 16 Jun 2001 11:11:45 -0400

silo (1.2.0-1) unstable; urgency=low

  * New upstream.

 -- Ben Collins <bcollins@debian.org>  Fri,  8 Jun 2001 12:56:59 -0400

silo (1.1.0-1) unstable; urgency=low

  * New upstream, adds support for tab completion on prom console, and
    also supports booting fujitsu sparc64 systems.
  * Added build-depends.
  * Changed priority from required to important, as per dinstall
    overrides.

 -- Ben Collins <bcollins@debian.org>  Mon, 28 May 2001 14:26:27 -0400

silo (1.0.1-1) unstable; urgency=low

  * New upstream.
  * Update silo1440k images.
  * Make siloconfig recognize a non-interactive install, and skip running.

 -- Ben Collins <bcollins@debian.org>  Mon, 28 May 2001 10:56:42 -0400

silo (1.0-1) unstable; urgency=high

  * Hey, I'm upstream maintainer now!
  * New upstream release. All patches merged.
  * Now includes tilo/maketilo. Replaces older sparc-utils

 -- Ben Collins <bcollins@debian.org>  Wed, 23 May 2001 12:30:05 -0400

silo (0.9.9.1-1) unstable; urgency=high

  * Provide the silo1440k base images for boot-floppies. This way, it
    doesn't have to be included on the root.bin, and we save about 100k
  * Urgency high, for boot-floppies

 -- Ben Collins <bcollins@debian.org>  Thu, 17 May 2001 20:22:15 -0400

silo (0.9.9.0-2) unstable; urgency=high

  * Call confcheck() after chroot()

 -- Ben Collins <bcollins@debian.org>  Thu, 17 May 2001 14:36:50 -0400

silo (0.9.9.0-1) unstable; urgency=low

  * Convert to using a db style source format. The silo upstream tarball
    contains some binary files that get changed during build. This makes
    it easier to contend with that fact.
  * Merged the conf check into the silo program itself. Right now it
    verifies irregardless. Next version I'll make it have an option to
    turn that off, or ignore failures.
  * This is not a new upstream. The pools setup does not allow me to do a
    new full source upload of the same version. Lucky for us, dpkg allows
    a .0 extended version to be > one without...dpkg is good for something
    :)

 -- Ben Collins <bcollins@debian.org>  Thu, 28 Dec 2000 08:32:40 -0500

silo (0.9.9-5) unstable; urgency=low

  * Fix typo in cfg.c
  * Added siloconfcheck to siloconfig

 -- Ben Collins <bcollins@debian.org>  Wed, 27 Dec 2000 16:55:50 -0500

silo (0.9.9-4) unstable; urgency=low

  * Created siloconfcheck program that validates a silo.conf file using
    the same rules (IOW, the exact same functions) used by the silo second
    stage boot loader. Helpful for validating conf files. closes: #38298

 -- Ben Collins <bcollins@debian.org>  Wed, 27 Dec 2000 12:55:09 -0500

silo (0.9.9-3) unstable; urgency=low

  * Changed priority to required, and make essential yes. There are a few
    cases (netboot) where silo isn't needed, but the thing is, we want
    people to know they might mess up their systems when removing this. So
    we force them to take that extra step.



=== debian/control ===
Source: silo
Section: base
Priority: important
Maintainer: Ben Collins <bcollins@debian.org>
Build-Depends: e2fslibs-dev, debhelper, gcc-2.95, bzip2
Standards-Version: 3.2.1.0

Package: silo
Architecture: sparc
Depends: ${shlibs:Depends}
Replaces: sparc-utils (<< 1.8-1)
Description: Sparc Improved LOader
 Like LILO or MILO, but for SPARC.
 This is the program you need to use if you plan to boot SPARC/Linux
 via a hard drive, floppy or CDROM.  It installs to the boot block of
 your system and will allow for booting of Linux, Solaris, and SunOS.

=== debian/rules ===
#!/usr/bin/make -f

# the dbs rules
TAR_DIR := silo-1.4.6
include debian/scripts/dbs-build.mk

build: $(STAMP_DIR)/build
$(STAMP_DIR)/build: $(STAMP_DIR)/patch
	dh_testdir
	cd $(BUILD_TREE) && $(MAKE)
	touch $(STAMP_DIR)/build

clean:
	dh_testdir
	rm -rf $(STAMP_DIR) $(SOURCE_DIR)
	perl debian/scripts/dh_split clean
	dh_clean

install: build $(dh_mak_deps)
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	cd $(BUILD_TREE) && $(MAKE) DESTDIR="$(shell pwd)/debian/tmp" \
		install
	install -m755 debian/local/siloconfig debian/tmp/usr/sbin/siloconfig

	dh_movefiles

binary-indep:

binary-arch: build install $(dh_mak_deps)
	dh_testdir
	dh_testroot
	dh_installdocs $(BUILD_TREE)/docs/{README{,.tilo}} $(BUILD_TREE)/first-isofs/README.SILO_ISOFS
	dh_installchangelogs $(BUILD_TREE)/ChangeLog
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-arch

## silo 1.4.8-1ubuntu1

=== debian/changelog ===
silo (1.4.8-1ubuntu1) hoary; urgency=low

  * Update build-deps.

 -- Fabio M. Di Nitto <fabbione@ubuntu.com>  Wed, 26 Jan 2005 07:19:46 +0100

silo (1.4.8-1) unstable; urgency=high

  * New upstream, really fixes initrd issues.

 -- Ben Collins <bcollins@debian.org>  Wed, 14 Jul 2004 10:35:40 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: base
 Priority: important
 Maintainer: Ben Collins <bcollins@debian.org>
-Build-Depends: e2fslibs-dev, debhelper, gcc-2.95, bzip2
+Build-Depends: e2fslibs-dev, debhelper, bzip2
 Standards-Version: 3.2.1.0
 
 Package: silo

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
 # the dbs rules
-TAR_DIR := silo-1.4.6
+TAR_DIR := silo-1.4.8
 include debian/scripts/dbs-build.mk
 
 build: $(STAMP_DIR)/build

## silo 1.4.9-1

=== tilo/Makefile ===
--- 
+++ 
@@ -21,7 +21,8 @@
 
 OBJS_COMMON = ../common/printf.o ../common/jmp.o ../common/prom.o \
 	../common/tree.o ../common/console.o ../common/stringops1.o \
-	../common/urem.o ../common/stringops2.o ../common/udiv.o
+	../common/urem.o ../common/stringops2.o ../common/udiv.o \
+	../common/divdi3.o ../common/udivdi3.o
 OBJS = crt0.o tilo.o $(OBJS_COMMON) malloc.o
 OBJS2 = crt0l.o tilol.o $(OBJS_COMMON) mallocl.o

=== debian/changelog ===
silo (1.4.9-1) unstable; urgency=low

  * Upgraded to silo 1.4.9
  * Added sparc-utils to build-deps. Closes #278126
  * Set CC to gcc-2.95

 -- Ben Collins <bcollins@debian.org>  Tue, 15 Mar 2005 09:06:46 -0500

silo (1.4.8-2) unstable; urgency=low

  * Added versioned build-dep for e2fslibs. Closes: #249335

 -- Ben Collins <bcollins@debian.org>  Wed, 14 Jul 2004 11:00:50 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Section: base
 Priority: important
 Maintainer: Ben Collins <bcollins@debian.org>
-Build-Depends: e2fslibs-dev, debhelper, bzip2
+Build-Depends: e2fslibs-dev (>= 1.28-1), debhelper, gcc-2.95, bzip2,
+	sparc-utils
 Standards-Version: 3.2.1.0
 
 Package: silo

=== debian/rules ===
--- 
+++ 
@@ -1,13 +1,15 @@
 #!/usr/bin/make -f
 
 # the dbs rules
-TAR_DIR := silo-1.4.8
+TAR_DIR := silo-1.4.9
 include debian/scripts/dbs-build.mk
+
+CC = "gcc-2.95 -m32"
 
 build: $(STAMP_DIR)/build
 $(STAMP_DIR)/build: $(STAMP_DIR)/patch
 	dh_testdir
-	cd $(BUILD_TREE) && $(MAKE)
+	cd $(BUILD_TREE) && $(MAKE) CC=$(CC)
 	touch $(STAMP_DIR)/build
 
 clean:

## silo 1.4.10-0ubuntu4

=== debian/changelog ===
silo (1.4.10-0ubuntu4) dapper;  urgency=low

  * Fix timer.c for real this time.

 -- Fabio M. Di Nitto <fabbione@ubuntu.com>  Fri, 21 Apr 2006 07:13:36 +0200

silo (1.4.10-0ubuntu3) dapper;  urgency=low

  * Revert back to silo (1.4.10-0ubuntu1) to fix boot issue on Niagara T1.

 -- Fabio M. Di Nitto <fabbione@ubuntu.com>  Wed, 19 Apr 2006 12:18:06 +0200

silo (1.4.10-0ubuntu2) dapper;  urgency=low

  * Revert changes to second/timer.c introduced by mistake when adding
    support to sun4v. This also fixes a regression in silo 1.4.11
    where the timeout option in silo.conf was not respected anylonger.
    - Update patch sun4v.

 -- Fabio M. Di Nitto <fabbione@ubuntu.com>  Sun, 16 Apr 2006 12:10:39 +0200

silo (1.4.10-0ubuntu1) dapper;  urgency=low

  UVF breakage granted by Matt.

  * New upstream version:
    - Drop build-with-gcc4 patch.

  * Add patch to support SUN4V.

 -- Fabio M. Di Nitto <fabbione@ubuntu.com>  Fri, 24 Feb 2006 06:22:48 +0100

silo (1.4.9-1ubuntu1) dapper; urgency=low

  * Resynchronise with Debian.

  * Apply patch from David Miller to build with gcc4.

 -- Fabio M. Di Nitto <fabbione@ubuntu.com>  Tue, 25 Oct 2005 08:44:03 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,7 @@
 Section: base
 Priority: important
 Maintainer: Ben Collins <bcollins@debian.org>
-Build-Depends: e2fslibs-dev (>= 1.28-1), debhelper, gcc-2.95, bzip2,
-	sparc-utils
+Build-Depends: e2fslibs-dev (>= 1.28-1), debhelper, bzip2, sparc-utils
 Standards-Version: 3.2.1.0
 
 Package: silo

=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,10 @@
 #!/usr/bin/make -f
 
 # the dbs rules
-TAR_DIR := silo-1.4.9
+TAR_DIR := silo-1.4.10
 include debian/scripts/dbs-build.mk
 
-CC = "gcc-2.95 -m32"
+CC = "gcc -m32"
 
 build: $(STAMP_DIR)/build
 $(STAMP_DIR)/build: $(STAMP_DIR)/patch

## silo 1.4.10-0ubuntu4.1

=== debian/changelog ===
silo (1.4.10-0ubuntu4.1) dapper-updates; urgency=low

  Changes by David S. Miller:

  * Fix CDROM booting on sparc64.
  (Closes Ubuntu: #40119 and duplicates)

 -- Fabio M. Di Nitto <fabbione@ubuntu.com>  Mon, 19 Jun 2006 06:55:54 +0200
